// File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.
import { APIResource } from 'cloudflare/resource';
import * as HistoryAPI from 'cloudflare/resources/alerting/history';
import { V4PagePaginationArray } from 'cloudflare/pagination';
export class History extends APIResource {
    /**
     * Gets a list of history records for notifications sent to an account. The records
     * are displayed for last `x` number of days based on the zone plan (free = 30, pro
     * = 30, biz = 30, ent = 90).
     */
    list(params, options) {
        const { account_id, ...query } = params;
        return this._client.getAPIList(`/accounts/${account_id}/alerting/v3/history`, AlertingHistoriesV4PagePaginationArray, { query, ...options });
    }
}
export class AlertingHistoriesV4PagePaginationArray extends V4PagePaginationArray {
}
(function (History) {
    History.AlertingHistoriesV4PagePaginationArray = HistoryAPI.AlertingHistoriesV4PagePaginationArray;
})(History || (History = {}));
//# sourceMappingURL=history.mjs.map