// File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.
import { APIResource } from 'cloudflare/resource';
import * as OriginCACertificatesAPI from 'cloudflare/resources/origin-ca-certificates';
import { SinglePage } from 'cloudflare/pagination';
export class OriginCACertificates extends APIResource {
    /**
     * Create an Origin CA certificate. Use your Origin CA Key as your User Service Key
     * when calling this endpoint ([see above](#requests)).
     */
    create(body, options) {
        return this._client.post('/certificates', { body, ...options })._thenUnwrap((obj) => obj.result);
    }
    /**
     * List all existing Origin CA certificates for a given zone. Use your Origin CA
     * Key as your User Service Key when calling this endpoint
     * ([see above](#requests)).
     */
    list(options) {
        return this._client.getAPIList('/certificates', OriginCACertificatesSinglePage, options);
    }
    /**
     * Revoke an existing Origin CA certificate by its serial number. Use your Origin
     * CA Key as your User Service Key when calling this endpoint
     * ([see above](#requests)).
     */
    delete(certificateId, options) {
        return this._client.delete(`/certificates/${certificateId}`, options)._thenUnwrap((obj) => obj.result);
    }
    /**
     * Get an existing Origin CA certificate by its serial number. Use your Origin CA
     * Key as your User Service Key when calling this endpoint
     * ([see above](#requests)).
     */
    get(certificateId, options) {
        return this._client.get(`/certificates/${certificateId}`, options)._thenUnwrap((obj) => obj.result);
    }
}
export class OriginCACertificatesSinglePage extends SinglePage {
}
(function (OriginCACertificates) {
    OriginCACertificates.OriginCACertificatesSinglePage = OriginCACertificatesAPI.OriginCACertificatesSinglePage;
})(OriginCACertificates || (OriginCACertificates = {}));
//# sourceMappingURL=origin-ca-certificates.mjs.map