import * as Core from 'cloudflare/core';
import { APIResource } from 'cloudflare/resource';
import * as SettingsAPI from 'cloudflare/resources/pagerules/settings';
export declare class Settings extends APIResource {
    /**
     * Returns a list of settings (and their details) that Page Rules can apply to
     * matching requests.
     */
    list(params: SettingListParams, options?: Core.RequestOptions): Core.APIPromise<ZonePageruleSettings>;
}
/**
 * Settings available for the zone.
 */
export type ZonePageruleSettings = Array<unknown>;
export interface SettingListParams {
    /**
     * Identifier
     */
    zone_id: string;
}
export declare namespace Settings {
    export import ZonePageruleSettings = SettingsAPI.ZonePageruleSettings;
    export import SettingListParams = SettingsAPI.SettingListParams;
}
//# sourceMappingURL=settings.d.ts.map