import * as Core from 'cloudflare/core';
import { APIResource } from 'cloudflare/resource';
import * as ByTagAPI from 'cloudflare/resources/rulesets/versions/by-tag';
import * as RulesetsAPI from 'cloudflare/resources/rulesets/rulesets';
export declare class ByTag extends APIResource {
    /**
     * Fetches the rules of a managed account ruleset version for a given tag.
     */
    get(rulesetId: string, rulesetVersion: string, ruleTag: string, params: ByTagGetParams, options?: Core.RequestOptions): Core.APIPromise<RulesetsAPI.Ruleset>;
}
export interface ByTagGetParams {
    /**
     * The unique ID of the account.
     */
    account_id: string;
}
export declare namespace ByTag {
    export import ByTagGetParams = ByTagAPI.ByTagGetParams;
}
//# sourceMappingURL=by-tag.d.ts.map