import * as Core from 'cloudflare/core';
import { APIResource } from 'cloudflare/resource';
import * as ForceAXFRAPI from 'cloudflare/resources/secondary-dns/force-axfr';
export declare class ForceAXFR extends APIResource {
    /**
     * Sends AXFR zone transfer request to primary nameserver(s).
     */
    create(params: ForceAXFRCreateParams, options?: Core.RequestOptions): Core.APIPromise<SecondaryDNSForce>;
}
/**
 * When force_axfr query parameter is set to true, the response is a simple string
 */
export type SecondaryDNSForce = string;
export interface ForceAXFRCreateParams {
    zone_id: string;
}
export declare namespace ForceAXFR {
    export import SecondaryDNSForce = ForceAXFRAPI.SecondaryDNSForce;
    export import ForceAXFRCreateParams = ForceAXFRAPI.ForceAXFRCreateParams;
}
//# sourceMappingURL=force-axfr.d.ts.map