"use strict";
// File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoadBalancingMonitorsSinglePage = exports.Monitors = void 0;
const resource_1 = require("cloudflare/resource");
const MonitorsAPI = __importStar(require("cloudflare/resources/user/load-balancers/monitors"));
const pagination_1 = require("cloudflare/pagination");
class Monitors extends resource_1.APIResource {
    /**
     * Create a configured monitor.
     */
    create(body, options) {
        return this._client.post('/user/load_balancers/monitors', { body, ...options })._thenUnwrap((obj) => obj.result);
    }
    /**
     * Modify a configured monitor.
     */
    update(monitorId, body, options) {
        return this._client.put(`/user/load_balancers/monitors/${monitorId}`, {
            body,
            ...options,
        })._thenUnwrap((obj) => obj.result);
    }
    /**
     * List configured monitors for a user.
     */
    list(options) {
        return this._client.getAPIList('/user/load_balancers/monitors', LoadBalancingMonitorsSinglePage, options);
    }
    /**
     * Delete a configured monitor.
     */
    delete(monitorId, options) {
        return this._client.delete(`/user/load_balancers/monitors/${monitorId}`, options)._thenUnwrap((obj) => obj.result);
    }
    /**
     * Apply changes to an existing monitor, overwriting the supplied properties.
     */
    edit(monitorId, body, options) {
        return this._client.patch(`/user/load_balancers/monitors/${monitorId}`, {
            body,
            ...options,
        })._thenUnwrap((obj) => obj.result);
    }
    /**
     * List a single configured monitor for a user.
     */
    get(monitorId, options) {
        return this._client.get(`/user/load_balancers/monitors/${monitorId}`, options)._thenUnwrap((obj) => obj.result);
    }
    /**
     * Preview pools using the specified monitor with provided monitor details. The
     * returned preview_id can be used in the preview endpoint to retrieve the results.
     */
    preview(monitorId, body, options) {
        return this._client.post(`/user/load_balancers/monitors/${monitorId}/preview`, {
            body,
            ...options,
        })._thenUnwrap((obj) => obj.result);
    }
    /**
     * Get the list of resources that reference the provided monitor.
     */
    references(monitorId, options) {
        return this._client.get(`/user/load_balancers/monitors/${monitorId}/references`, options)._thenUnwrap((obj) => obj.result);
    }
}
exports.Monitors = Monitors;
class LoadBalancingMonitorsSinglePage extends pagination_1.SinglePage {
}
exports.LoadBalancingMonitorsSinglePage = LoadBalancingMonitorsSinglePage;
(function (Monitors) {
    Monitors.LoadBalancingMonitorsSinglePage = MonitorsAPI.LoadBalancingMonitorsSinglePage;
})(Monitors = exports.Monitors || (exports.Monitors = {}));
//# sourceMappingURL=monitors.js.map