import * as Core from 'cloudflare/core';
import { APIResource } from 'cloudflare/resource';
import * as PreviewAPI from 'cloudflare/resources/user/load-balancers/preview';
export declare class Preview extends APIResource {
    /**
     * Get the result of a previous preview operation using the provided preview_id.
     */
    get(previewId: string, options?: Core.RequestOptions): Core.APIPromise<LoadBalancingPreview>;
}
/**
 * Resulting health data from a preview operation.
 */
export type LoadBalancingPreview = Record<string, LoadBalancingPreview.unnamed_schema_with_map_parent_0>;
export declare namespace LoadBalancingPreview {
    interface unnamed_schema_with_map_parent_0 {
        healthy?: boolean;
        origins?: Array<Record<string, unnamed_schema_with_map_parent_0.load_balancing_origin_health_data>>;
    }
    namespace unnamed_schema_with_map_parent_0 {
        /**
         * The origin ipv4/ipv6 address or domain name mapped to it's health data.
         */
        interface load_balancing_origin_health_data {
            failure_reason?: string;
            healthy?: boolean;
            response_code?: number;
            rtt?: string;
        }
    }
}
export declare namespace Preview {
    export import LoadBalancingPreview = PreviewAPI.LoadBalancingPreview;
}
//# sourceMappingURL=preview.d.ts.map