"use strict";
// File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VectorizeCreateIndicesSinglePage = exports.Indexes = void 0;
const resource_1 = require("cloudflare/resource");
const IndexesAPI = __importStar(require("cloudflare/resources/vectorize/indexes"));
const pagination_1 = require("cloudflare/pagination");
class Indexes extends resource_1.APIResource {
    /**
     * Creates and returns a new Vectorize Index.
     */
    create(accountIdentifier, body, options) {
        return this._client.post(`/accounts/${accountIdentifier}/vectorize/indexes`, {
            body,
            ...options,
        })._thenUnwrap((obj) => obj.result);
    }
    /**
     * Updates and returns the specified Vectorize Index.
     */
    update(accountIdentifier, indexName, body, options) {
        return this._client.put(`/accounts/${accountIdentifier}/vectorize/indexes/${indexName}`, {
            body,
            ...options,
        })._thenUnwrap((obj) => obj.result);
    }
    /**
     * Returns a list of Vectorize Indexes
     */
    list(accountIdentifier, options) {
        return this._client.getAPIList(`/accounts/${accountIdentifier}/vectorize/indexes`, VectorizeCreateIndicesSinglePage, options);
    }
    /**
     * Deletes the specified Vectorize Index.
     */
    delete(accountIdentifier, indexName, options) {
        return this._client.delete(`/accounts/${accountIdentifier}/vectorize/indexes/${indexName}`, options)._thenUnwrap((obj) => obj.result);
    }
    /**
     * Delete a set of vectors from an index by their vector identifiers.
     */
    deleteByIds(accountIdentifier, indexName, body, options) {
        return this._client.post(`/accounts/${accountIdentifier}/vectorize/indexes/${indexName}/delete-by-ids`, {
            body,
            ...options,
        })._thenUnwrap((obj) => obj.result);
    }
    /**
     * Returns the specified Vectorize Index.
     */
    get(accountIdentifier, indexName, options) {
        return this._client.get(`/accounts/${accountIdentifier}/vectorize/indexes/${indexName}`, options)._thenUnwrap((obj) => obj.result);
    }
    /**
     * Get a set of vectors from an index by their vector identifiers.
     */
    getByIds(accountIdentifier, indexName, body, options) {
        return this._client.post(`/accounts/${accountIdentifier}/vectorize/indexes/${indexName}/get-by-ids`, {
            body,
            ...options,
        })._thenUnwrap((obj) => obj.result);
    }
    /**
     * Inserts vectors into the specified index and returns the count of the vectors
     * successfully inserted.
     */
    insert(accountIdentifier, indexName, body, options) {
        return this._client.post(`/accounts/${accountIdentifier}/vectorize/indexes/${indexName}/insert`, options)._thenUnwrap((obj) => obj.result);
    }
    /**
     * Finds vectors closest to a given vector in an index.
     */
    query(accountIdentifier, indexName, body, options) {
        return this._client.post(`/accounts/${accountIdentifier}/vectorize/indexes/${indexName}/query`, {
            body,
            ...options,
        })._thenUnwrap((obj) => obj.result);
    }
    /**
     * Upserts vectors into the specified index, creating them if they do not exist and
     * returns the count of values and ids successfully inserted.
     */
    upsert(accountIdentifier, indexName, body, options) {
        return this._client.post(`/accounts/${accountIdentifier}/vectorize/indexes/${indexName}/upsert`, options)._thenUnwrap((obj) => obj.result);
    }
}
exports.Indexes = Indexes;
class VectorizeCreateIndicesSinglePage extends pagination_1.SinglePage {
}
exports.VectorizeCreateIndicesSinglePage = VectorizeCreateIndicesSinglePage;
(function (Indexes) {
    Indexes.VectorizeCreateIndicesSinglePage = IndexesAPI.VectorizeCreateIndicesSinglePage;
})(Indexes = exports.Indexes || (exports.Indexes = {}));
//# sourceMappingURL=indexes.js.map