import * as Core from 'cloudflare/core';
import { APIResource } from 'cloudflare/resource';
import * as ContentListsAPI from 'cloudflare/resources/web3/hostnames/ipfs-universal-paths/content-lists/content-lists';
import * as EntriesAPI from 'cloudflare/resources/web3/hostnames/ipfs-universal-paths/content-lists/entries';
export declare class ContentLists extends APIResource {
    entries: EntriesAPI.Entries;
    /**
     * Update IPFS Universal Path Gateway Content List
     */
    update(zoneIdentifier: string, identifier: string, body: ContentListUpdateParams, options?: Core.RequestOptions): Core.APIPromise<DistributedWebConfigContentList>;
    /**
     * IPFS Universal Path Gateway Content List Details
     */
    get(zoneIdentifier: string, identifier: string, options?: Core.RequestOptions): Core.APIPromise<DistributedWebConfigContentList>;
}
export interface DistributedWebConfigContentList {
    /**
     * Behavior of the content list.
     */
    action?: 'block';
}
export interface ContentListUpdateParams {
    /**
     * Behavior of the content list.
     */
    action: 'block';
    /**
     * Content list entries.
     */
    entries: Array<EntriesAPI.DistributedWebConfigContentListEntry>;
}
export declare namespace ContentLists {
    export import DistributedWebConfigContentList = ContentListsAPI.DistributedWebConfigContentList;
    export import ContentListUpdateParams = ContentListsAPI.ContentListUpdateParams;
    export import Entries = EntriesAPI.Entries;
    export import DistributedWebConfigContentListEntry = EntriesAPI.DistributedWebConfigContentListEntry;
    export import EntryListResponse = EntriesAPI.EntryListResponse;
    export import EntryDeleteResponse = EntriesAPI.EntryDeleteResponse;
    export import EntryCreateParams = EntriesAPI.EntryCreateParams;
    export import EntryUpdateParams = EntriesAPI.EntryUpdateParams;
}
//# sourceMappingURL=content-lists.d.ts.map