"use strict";
// File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkersFiltersSinglePage = exports.Filters = void 0;
const resource_1 = require("cloudflare/resource");
const FiltersAPI = __importStar(require("cloudflare/resources/workers/filters"));
const pagination_1 = require("cloudflare/pagination");
class Filters extends resource_1.APIResource {
    /**
     * Create Filter
     */
    create(params, options) {
        const { zone_id, ...body } = params;
        return this._client.post(`/zones/${zone_id}/workers/filters`, { body, ...options })._thenUnwrap((obj) => obj.result);
    }
    /**
     * Update Filter
     */
    update(filterId, params, options) {
        const { zone_id, ...body } = params;
        return this._client.put(`/zones/${zone_id}/workers/filters/${filterId}`, {
            body,
            ...options,
        })._thenUnwrap((obj) => obj.result);
    }
    /**
     * List Filters
     */
    list(params, options) {
        const { zone_id } = params;
        return this._client.getAPIList(`/zones/${zone_id}/workers/filters`, WorkersFiltersSinglePage, options);
    }
    /**
     * Delete Filter
     */
    delete(filterId, params, options) {
        const { zone_id } = params;
        return this._client.delete(`/zones/${zone_id}/workers/filters/${filterId}`, options)._thenUnwrap((obj) => obj.result);
    }
}
exports.Filters = Filters;
class WorkersFiltersSinglePage extends pagination_1.SinglePage {
}
exports.WorkersFiltersSinglePage = WorkersFiltersSinglePage;
(function (Filters) {
    Filters.WorkersFiltersSinglePage = FiltersAPI.WorkersFiltersSinglePage;
})(Filters = exports.Filters || (exports.Filters = {}));
//# sourceMappingURL=filters.js.map