// File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.
import { APIResource } from 'cloudflare/resource';
import * as FiltersAPI from 'cloudflare/resources/workers/filters';
import { SinglePage } from 'cloudflare/pagination';
export class Filters extends APIResource {
    /**
     * Create Filter
     */
    create(params, options) {
        const { zone_id, ...body } = params;
        return this._client.post(`/zones/${zone_id}/workers/filters`, { body, ...options })._thenUnwrap((obj) => obj.result);
    }
    /**
     * Update Filter
     */
    update(filterId, params, options) {
        const { zone_id, ...body } = params;
        return this._client.put(`/zones/${zone_id}/workers/filters/${filterId}`, {
            body,
            ...options,
        })._thenUnwrap((obj) => obj.result);
    }
    /**
     * List Filters
     */
    list(params, options) {
        const { zone_id } = params;
        return this._client.getAPIList(`/zones/${zone_id}/workers/filters`, WorkersFiltersSinglePage, options);
    }
    /**
     * Delete Filter
     */
    delete(filterId, params, options) {
        const { zone_id } = params;
        return this._client.delete(`/zones/${zone_id}/workers/filters/${filterId}`, options)._thenUnwrap((obj) => obj.result);
    }
}
export class WorkersFiltersSinglePage extends SinglePage {
}
(function (Filters) {
    Filters.WorkersFiltersSinglePage = FiltersAPI.WorkersFiltersSinglePage;
})(Filters || (Filters = {}));
//# sourceMappingURL=filters.mjs.map